----------------------------- PlanExamples.maude -----------------------------
--- Date: Mon, 27 Aug 2001 22:37:40 +0200
--- From: Francesco Bellomi <fbellomi@libero.it>
--- extended by clt 01oct16
---   several factorials (local,  OnNeighbor, surfing Neighbors, following
---   a path ), 

fmod FACTORIAL-EXAMPLES is
***    including PLAN-LITERALS .
***    including PLAN-NETWORK .
    including PLAN-SEMANTICS  .   *** need cast from semantics for setup

    --- Simple Factorial 
    
    op FactorialExample1 : MachineInt -> Ex .
    vars fint rbint : MachineInt .
    var nbr  : Addr .

    eq FactorialExample1(fint) =
        (LetRec ["fact" = Lam ["x" : TInt]
           (If (Equal ("x"{0}, (Int 0)))
                Then (Int 1)
                Else (Mul ("x"{0}, ("fact"{0} (Minus ("x"{0}, (Int 1)))))))]
           ("fact"{0} (Int fint))) .

    --- Factorial using OnNeighbor

    op FactorialExample2 : MachineInt Addr -> Ex .
    
    eq FactorialExample2(fint, nbr) =
      (LetRec ["fact" = Lam ["x" : TInt]
         (If (Equal ("x"{0},(Int 0)))
          Then (Int 1)
          Else (Mul ("x"{0}, ("fact"{0} (Minus ("x"{0}, (Int 1)))))))]
      (Let ["odev" = (GetDevToHost (Addr nbr))]
      (OnNeighbor ((Chunk ("fact"{0}, (Int fint))),
                        (Addr nbr), (Int 50), "odev"{0})))) .
    
   --- Factorial cruising the net
    
    op FactorialExample3 : MachineInt  -> Ex .
    
    eq FactorialExample3(fint) =
      (LetRec ["reply" = Lam ["ans" : TInt] (Print "ans"{0})]
      (LetRec ["tfact" = Lam ["x", "ans" : TInt, TInt]
        (Let ["rb" = (GetRB empty-exl)]
         (If (Equal ("x"{0},(Int 1)))
          Then
            (Let ["src" = (GetSource empty-exl)]
              (If (ThisHostIs "src"{0}) 
               Then (Print "ans"{0})
               Else (OnRemote ( (Chunk ("reply"{0}, "ans"{0})), 
                         "src"{0}, "rb"{0}, DefaultRoute)) ))
          Else 
            (Let ["nbrs" = (GetNeighbors empty-exl)]
            (Let ["cnx" = (Hd "nbrs"{0})]
            (Let [("nbr", "odev") = ((Fst "cnx"{0}), (Snd "cnx"{0}))]
             (OnNeighbor 
               ((Chunk ("tfact"{0}, 
                        ((Minus ("x"{0},(Int 1))), (Mul ("x"{0},"ans"{0}))))),
                        "nbr"{0}, "rb"{0}, "odev"{0})) ))) ) )]
           ("tfact"{0} (Int fint, Int 1)) ))  .

    op FactorialExample4 : MachineInt AddrList -> Ex .
    var adl : AddrList .
    
    eq FactorialExample4(fint, adl) =
      (LetRec ["reply" = Lam ["ans" : TInt] (Print "ans"{0})]
      (LetRec ["tfact" = Lam ["x", "ans", "path" : TInt, TInt, (TList TAddr)]
        (Let ["rb" = (GetRB empty-exl)]
         (If (Equal ("x"{0},(Int 1)))
          Then
            (OnRemote ( (Chunk ("reply"{0}, "ans"{0})), 
                         (GetSource empty-exl), "rb"{0}, DefaultRoute))
          Else 
            (If (Equal ("path"{0}, Nil))
             Then
               (OnRemote ( (Chunk (Print, String("end-of-path"))), 
                           (GetSource empty-exl), "rb"{0}, DefaultRoute))
             Else
               (OnRemote ( (Chunk ("tfact"{0}, 
                                   ((Minus ("x"{0},(Int 1))), 
                                    (Mul ("x"{0},"ans"{0})),
                                    (Tl "path"{0})) )),
                            (Hd "path"{0}), "rb"{0}, DefaultRoute)) )))]
           ("tfact"{0} (Int fint, Int 1, cast(adl))) ))  .
   
endfm

mod FACTORIAL-RUNS is

including FACTORIAL-EXAMPLES .
including PLAN-SEMANTICS .
including TOPOLOGIES .

endm

***(
in p.m
in topologies.m
in fact-examples.m

rew RedState(?,FactorialExample1(7)) .

rewrites: 3591 in 30ms cpu (52ms real) (119700 rewrites/second)
result RedState: RedState(?, Int 5040)

rew example-topology-1
    Process(loc("l1"), addr("i1"), addr("i1"), 1, 100, 
      RedState(?, FactorialExample2(5, addr("a2")))) .
rewrites: 3048 in 90ms cpu (97ms real) (33866 rewrites/second)
result Configuration: FreshKey(10) Data(loc("l1"), empty-dil) ... Nodes
  Process(loc("l1"), addr("i1"), addr("i1"), 1, 50, RedState(?, Dummy)) 
  Process(loc("l2"), addr("i1"), addr("a2"), 1, 49, RedState(?, Int 120))

rew example-topology-1
    Process(loc("l4"), addr("i1"), addr("b4"), 1, 100, 
      RedState(?, FactorialExample2(5, addr("b3")))) .
rewrites: 3063 in 80ms cpu (88ms real) (38287 rewrites/second)
result Configuration: FreshKey(10) Data ... Nodes ...
    Process(loc("l3"), addr("i1"), addr("b3"), 1, 49, RedState(?, Int 120)) 
    Process(loc("l4"), addr("i1"), addr("b4"), 1, 50, RedState(?, Dummy))
 
rew example-topology-1
    Process(loc("l1"), addr("a1"), addr("i1"), 1, 100, 
      RedState(?, FactorialExample3(6))) .
rewrites: 68961 in 880ms cpu (890ms real) (78364 rewrites/second)
result Configuration: 
   example-topology-1
 Process(loc("l1"), addr("a1"), addr("a1"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l1"), addr("a1"), addr("a1"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l1"), addr("a1"), addr("a1"), 1, 94, RedState(?, Print Int 720))
 Process(loc("l1"), addr("a1"), addr("i1"), 1, 0, RedState(?, Dummy))
 Process(loc("l2"), addr("a1"), addr("a2"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l2"), addr("a1"), addr("a2"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l2"), addr("a1"), addr("a2"), 1, 0, RedState(?, Dummy))

rew example-topology-1
    Process(loc("l1"), addr("a1"), addr("i1"), 1, 100, 
      RedState(?, FactorialExample3(5))) .
rewrites: 61034 in 710ms cpu (704ms real) (85963 rewrites/second)
result Configuration:
  example-topology-1
  Process(loc("l1"), addr("a1"), addr("a1"), 1, 0, RedState(?,
    Dummy)) Process(loc("l1"), addr("a1"), addr("a1"), 1, 96, RedState(?, Print
    Int 120)) Process(loc("l1"), addr("a1"), addr("i1"), 1, 0, RedState(?,
    Dummy)) Process(loc("l2"), addr("a1"), addr("a2"), 1, 0, RedState(?,
    Dummy)) Process(loc("l2"), addr("a1"), addr("a2"), 1, 0, RedState(?,
    Dummy))

rew example-topology-2
    Process(loc("l5"), addr("d5"), addr("d5"), 1, 100, 
      RedState(?, FactorialExample3(5))) .
rewrites: 61587 in 790ms cpu (791ms real) (77958 rewrites/second)
result Configuration:
  example-topology-2
  Process(loc("l0"), addr("d5"), addr("a0"), 1, 0, RedState(?,
    Dummy)) Process(loc("l1"), addr("d5"), addr("a1"), 1, 0, RedState(?,
    Dummy)) Process(loc("l1"), addr("d5"), addr("b1"), 1, 0, RedState(?,
    Dummy)) Process(loc("l2"), addr("d5"), addr("b2"), 1, 0, RedState(?,
    Dummy)) Process(loc("l2"), addr("d5"), addr("d2"), 1, 0, RedState(?,
    Dummy)) Process(loc("l5"), addr("d5"), addr("d5"), 1, 0, RedState(?,
    Dummy)) Process(loc("l5"), addr("d5"), addr("d5"), 1, 94, RedState(?, Print
    Int 120))

red cast(addr("a2"),addr("b4"),addr("b3"),addr("b2")) .

rew example-topology-1 
  Process(loc("l1"), addr("a1"), addr("i1"), 1, 100, RedState(?, 
    FactorialExample4(3,(addr("a2"),addr("a1"),addr("b4"))))) .
rewrites: 24410 in 330ms cpu (337ms real) (73969 rewrites/second)
result Configuration:
  example-topology-1
  Process(loc("l1"), addr("a1"), addr("a1"), 1, 0, RedState(?, Dummy)) 
  Process(loc("l1"), addr("a1"), addr("a1"), 1, 97, RedState(?, Print Int 6)) 
  Process(loc("l1"), addr("a1"), addr("i1"), 1, 0, RedState(?, Dummy))
  Process(loc("l2"), addr("a1"), addr("a2"), 1, 0, RedState(?, Dummy))


rew example-topology-1
    Process(loc("l1"), addr("a1"), addr("i1"), 1, 100, RedState(?, 
      FactorialExample4(5,(addr("a2"),addr("b4"),addr("b3"),addr("b2"))))) .
rewrites: 42269 in 580ms cpu (585ms real) (72877 rewrites/second)
result Configuration: 
 example-topology-1
 Process(loc("l1"), addr("a1"), addr("a1"), 1, 95, RedState(?, Print Int 120))
 Process(loc("l1"), addr("a1"), addr("i1"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l2"), addr("a1"), addr("a2"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l2"), addr("a1"), addr("b2"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l3"), addr("a1"), addr("b3"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l4"), addr("a1"), addr("b4"), 1, 0, RedState(?, Dummy))


rew example-topology-1
    Process(loc("l1"), addr("a1"), addr("i1"), 1, 100, RedState(?, 
      FactorialExample4(5,(addr("b4"),addr("b3"))) )) .
rewrites: 25883 in 370ms cpu (366ms real) (69954 rewrites/second)
result Configuration:
 example-topology-1
 Process(loc("l1"), addr("a1"), addr("a1"), 1, 95, RedState(?,
    Print String "end-of-path")) 
 Process(loc("l1"), addr("a1"), addr("i1"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l2"), addr("a1"), addr("a2"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l2"), addr("a1"), addr("b2"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l3"), addr("a1"), addr("b3"), 1, 0, RedState(?, Dummy)) 
 Process(loc("l4"), addr("a1"), addr("b4"), 1, 0, RedState(?, Dummy))

)
